"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var home_service_1 = require("./home.service");
var AppComponent = (function () {
    function AppComponent(_homeService) {
        this._homeService = _homeService;
        this.gridHome = [];
        this.users = [];
        this.validationRes = true;
        var me = this;
        this.validatorOpts = {
            fields: [],
            custom: {
                onblur: true,
                method: function (value, fieldOps) {
                    $("#TestTypeGrid_updating_dialog_container_footer_buttonok").igButton("option", "disabled", !me.validationRes);
                    return me.validationRes;
                },
                errorMessage: "user doesn't exist"
            }
        };
        //this.data = this.ErrorTypes;
        this.id = 'TestTypeGrid';
        this.gridOptions = {
            //autoCommit: true,
            dataSource: this.gridHome,
            width: "100%",
            height: "710px",
            autoGenerateColumns: false,
            rendered: function (e, ui) {
                //ui.owner.dataSource.settings.restSettings.contentType = undefined;
                //$.ajaxSetup({
                //    url: "",
                //    xhrFields: {
                //        withCredentials: true
                //    }
                //})
            },
            columns: [
                { key: "userId", headerText: "userId", width: "20%", dataType: "number" },
                { key: "id", headerText: "id", width: "20%", dataType: "number" },
                { key: "title", headerText: "title", width: "20%", dataType: "string" },
                { key: "body", headerText: "body", width: "60%", dataType: "string" },
            ],
            primaryKey: "id",
            features: [
                {
                    name: "Updating",
                    editMode: "dialog",
                    rowEditDialogAfterOpen: function (e, ui) {
                        if ($("#customValidator").data("igValidator").options.fields.length === 0) {
                            $("#customValidator").igValidator("addField", { selector: $("input[data-editor-for-userId]") });
                        }
                    },
                    editRowStarted: function (evt, ui) {
                        //var editor = $("#TestTypeGrid").igGridUpdating("editorForKey", "userId");
                        //if (editor) {
                        //    editor.igCombo("option", "dataSource", me.users);
                        //    editor.igCombo("dataBind");
                        //}
                    },
                    columnSettings: [
                        { columnKey: "id", readOnly: true, editorType: 'text' },
                        {
                            columnKey: "userId",
                            editorType: 'text',
                            required: true,
                            editorOptions: {
                                valueChanged: function (e, ui) {
                                    me._homeService.validateUser(ui.newValue)
                                        .subscribe(function (data) {
                                        if (data) {
                                            me.validationRes = true;
                                        }
                                        else {
                                            me.validationRes = false;
                                        }
                                        jQuery("#customValidator").igValidator("validate");
                                    }, function (error) {
                                        me.validationRes = false;
                                        jQuery("#customValidator").igValidator("validate");
                                    });
                                }
                            }
                        }
                    ]
                },
                {
                    name: "Paging"
                },
                {
                    name: "Filtering"
                },
                {
                    name: "Sorting"
                }
            ]
        };
    }
    AppComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._homeService.getHome()
            .subscribe(function (data) {
            _this.gridHome = data;
        }, function (error) { return _this.errorMessage = error; });
        this._homeService.getUsers()
            .subscribe(function (data) {
            _this.users = data;
        }, function (error) { return _this.errorMessage = error; });
    };
    AppComponent.prototype.clicked = function () {
        //trigger your remote call and in the result callback force validation by calling the validate method.
        this.validationRes = false;
        jQuery("#customValidator").igValidator("validate");
    };
    return AppComponent;
}());
AppComponent = __decorate([
    core_1.Component({
        selector: 'my-app',
        template: "<h1 id='mainheader'>My IgniteUI Angular2 App</h1>\n    <h2>igGrid</h2>\n<button type=\"button\" id=\"btnSave\" class=\"btn btn-success no-print\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"Save\" (click)=\"saveGrid()\">Save</button>\n<ig-grid [(options)]=\"gridOptions\" [(widgetId)]='id' [(dataSource)]=\"gridHome\"></ig-grid>\n    <div id='customValidator'></div>\n    <ig-validator [options]='validatorOpts'  widgetId='customValidator'></ig-validator>\n    ",
        providers: [home_service_1.HomeService]
    }),
    __metadata("design:paramtypes", [home_service_1.HomeService])
], AppComponent);
exports.AppComponent = AppComponent;
//# sourceMappingURL=app.component.js.map